import _objectWithoutProperties from "babel-runtime/helpers/objectWithoutProperties";
import _extends from "babel-runtime/helpers/extends";
// import PropTypes from "prop-types";
import p from "solomon-class-prefix";
// import { Link } from "react-router-dom";
import { Icon, Menu } from "antd";
import React from "react";
import { Scrollbars } from "react-custom-scrollbars";

var CLS_PREFIX = "solomon-layout-base";
var addPrefix = p(CLS_PREFIX);

var SubMenu = Menu.SubMenu;

/**
 * 递归渲染菜单
 *
 * @param data
 * @returns {*}
 */

var renderMenu = function renderMenu() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  if (data.length <= 0) {
    return null;
  }
  return data.map(function (_ref) {
    var key = _ref.key,
        children = _ref.children,
        icon = _ref.icon,
        _ref$title = _ref.title,
        title = _ref$title === undefined ? "" : _ref$title,
        link = _ref.link;

    var iconComp = icon ? React.createElement(Icon, { type: icon }) : null;
    if (children) {
      return React.createElement(
        SubMenu,
        {
          key: key,
          title: React.createElement(
            "span",
            null,
            iconComp,
            React.createElement(
              "span",
              null,
              title
            )
          )
        },
        renderMenu(children)
      );
    } else {
      return React.createElement(
        Menu.Item,
        { key: key, link: link },
        React.createElement(
          React.Fragment,
          null,
          iconComp,
          React.createElement(
            "span",
            null,
            title
          )
        )
      );
    }
  });
};

var BaseMenu = function BaseMenu(_ref2) {
  var collapsed = _ref2.collapsed,
      menuData = _ref2.menuData,
      menuOptions = _ref2.menuOptions;
  var logoRender = menuOptions.logoRender,
      _menuOptions$width = menuOptions.width,
      width = _menuOptions$width === undefined ? 256 : _menuOptions$width;

  var newMenuOptions = _extends({
    mode: "inline",
    theme: "dark"
  }, menuOptions, {
    selectedKeys: [menuOptions.selectedkey],
    inlineCollapsed: collapsed
  });
  delete newMenuOptions.logoRender;
  delete newMenuOptions.selectedkey;

  // const menuProps = { mode: "inline", theme: "dark" };
  var styles = {
    height: "100%"
  };
  if (!collapsed) {
    styles.flex = "0 0 " + width + "px";
    styles.maxWidth = width + "px";
    styles.minWidth = width + "px";
    styles.width = width + "px";
  } else {
    delete newMenuOptions.openKeys;
    styles.flex = "0 0 80px";
    styles.maxWidth = "80px";
    styles.minWidth = "80px";
    styles.width = "80px";
  }

  var _newMenuOptions$fixed = newMenuOptions.fixed,
      fixedLiftMenu = _newMenuOptions$fixed === undefined ? false : _newMenuOptions$fixed,
      _newMenuOptions$logoH = newMenuOptions.logoHeight,
      logoHeight = _newMenuOptions$logoH === undefined ? 64 : _newMenuOptions$logoH;

  delete newMenuOptions.fixed;

  var menuContentStyles = {};

  if (fixedLiftMenu) {
    styles.position = "fixed";
    styles.top = 0;
    styles.left = 0;

    menuContentStyles.position = "relative";
    // menuContentStyles.overflowY = "auto";
    menuContentStyles.height = "calc(100vh - " + logoHeight + "px)";

    newMenuOptions.style = menuContentStyles;
  }
  var renderThumbVertical = function renderThumbVertical(_ref3) {
    var style = _ref3.style,
        props = _objectWithoutProperties(_ref3, ["style"]);

    var thumbStyle = {
      backgroundColor: "rgba(201, 201, 201, 0.8)",
      borderRadius: "10px",
      width: "6px"
    };
    return React.createElement("div", _extends({ style: _extends({}, style, thumbStyle) }, props));
  };

  return React.createElement(
    "div",
    {
      className: "ant-layout-sider ant-layout-sider-dark " + (collapsed ? "ant-layout-sider-collapsed" : ""),
      style: styles
    },
    React.createElement(
      "div",
      { className: "ant-layout-sider-children" },
      React.createElement(
        "div",
        { className: addPrefix("menu") },
        typeof logoRender === "function" && logoRender(),
        React.createElement(
          Scrollbars,
          {
            autoHide: true,
            style: { height: newMenuOptions.style.height },
            renderThumbVertical: renderThumbVertical
          },
          React.createElement(
            Menu,
            _extends({ id: "solomon-menu-content" }, newMenuOptions),
            renderMenu(menuData, !collapsed)
          )
        )
      )
    )
  );
};

// BaseMenu.defaultProps = {
//   collapsed: false,
// };

// BaseMenu.propTypes = {
//   collapsed: PropTypes.bool,
// };

export default BaseMenu;