"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _objectWithoutProperties2 = require("babel-runtime/helpers/objectWithoutProperties");

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _solomonClassPrefix = require("solomon-class-prefix");

var _solomonClassPrefix2 = _interopRequireDefault(_solomonClassPrefix);

var _antd = require("antd");

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactCustomScrollbars = require("react-custom-scrollbars");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// import PropTypes from "prop-types";
var CLS_PREFIX = "solomon-layout-base";
// import { Link } from "react-router-dom";

var addPrefix = (0, _solomonClassPrefix2["default"])(CLS_PREFIX);

var SubMenu = _antd.Menu.SubMenu;

/**
 * 递归渲染菜单
 *
 * @param data
 * @returns {*}
 */

var renderMenu = function renderMenu() {
  var data = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  if (data.length <= 0) {
    return null;
  }
  return data.map(function (_ref) {
    var key = _ref.key,
        children = _ref.children,
        icon = _ref.icon,
        _ref$title = _ref.title,
        title = _ref$title === undefined ? "" : _ref$title,
        link = _ref.link;

    var iconComp = icon ? _react2["default"].createElement(_antd.Icon, { type: icon }) : null;
    if (children) {
      return _react2["default"].createElement(
        SubMenu,
        {
          key: key,
          title: _react2["default"].createElement(
            "span",
            null,
            iconComp,
            _react2["default"].createElement(
              "span",
              null,
              title
            )
          )
        },
        renderMenu(children)
      );
    } else {
      return _react2["default"].createElement(
        _antd.Menu.Item,
        { key: key, link: link },
        _react2["default"].createElement(
          _react2["default"].Fragment,
          null,
          iconComp,
          _react2["default"].createElement(
            "span",
            null,
            title
          )
        )
      );
    }
  });
};

var BaseMenu = function BaseMenu(_ref2) {
  var collapsed = _ref2.collapsed,
      menuData = _ref2.menuData,
      menuOptions = _ref2.menuOptions;
  var logoRender = menuOptions.logoRender,
      _menuOptions$width = menuOptions.width,
      width = _menuOptions$width === undefined ? 256 : _menuOptions$width;

  var newMenuOptions = (0, _extends3["default"])({
    mode: "inline",
    theme: "dark"
  }, menuOptions, {
    selectedKeys: [menuOptions.selectedkey],
    inlineCollapsed: collapsed
  });
  delete newMenuOptions.logoRender;
  delete newMenuOptions.selectedkey;

  // const menuProps = { mode: "inline", theme: "dark" };
  var styles = {
    height: "100%"
  };
  if (!collapsed) {
    styles.flex = "0 0 " + width + "px";
    styles.maxWidth = width + "px";
    styles.minWidth = width + "px";
    styles.width = width + "px";
  } else {
    delete newMenuOptions.openKeys;
    styles.flex = "0 0 80px";
    styles.maxWidth = "80px";
    styles.minWidth = "80px";
    styles.width = "80px";
  }

  var _newMenuOptions$fixed = newMenuOptions.fixed,
      fixedLiftMenu = _newMenuOptions$fixed === undefined ? false : _newMenuOptions$fixed,
      _newMenuOptions$logoH = newMenuOptions.logoHeight,
      logoHeight = _newMenuOptions$logoH === undefined ? 64 : _newMenuOptions$logoH;

  delete newMenuOptions.fixed;

  var menuContentStyles = {};

  if (fixedLiftMenu) {
    styles.position = "fixed";
    styles.top = 0;
    styles.left = 0;

    menuContentStyles.position = "relative";
    // menuContentStyles.overflowY = "auto";
    menuContentStyles.height = "calc(100vh - " + logoHeight + "px)";

    newMenuOptions.style = menuContentStyles;
  }
  var renderThumbVertical = function renderThumbVertical(_ref3) {
    var style = _ref3.style,
        props = (0, _objectWithoutProperties3["default"])(_ref3, ["style"]);

    var thumbStyle = {
      backgroundColor: "rgba(201, 201, 201, 0.8)",
      borderRadius: "10px",
      width: "6px"
    };
    return _react2["default"].createElement("div", (0, _extends3["default"])({ style: (0, _extends3["default"])({}, style, thumbStyle) }, props));
  };

  return _react2["default"].createElement(
    "div",
    {
      className: "ant-layout-sider ant-layout-sider-dark " + (collapsed ? "ant-layout-sider-collapsed" : ""),
      style: styles
    },
    _react2["default"].createElement(
      "div",
      { className: "ant-layout-sider-children" },
      _react2["default"].createElement(
        "div",
        { className: addPrefix("menu") },
        typeof logoRender === "function" && logoRender(),
        _react2["default"].createElement(
          _reactCustomScrollbars.Scrollbars,
          {
            autoHide: true,
            style: { height: newMenuOptions.style.height },
            renderThumbVertical: renderThumbVertical
          },
          _react2["default"].createElement(
            _antd.Menu,
            (0, _extends3["default"])({ id: "solomon-menu-content" }, newMenuOptions),
            renderMenu(menuData, !collapsed)
          )
        )
      )
    )
  );
};

// BaseMenu.defaultProps = {
//   collapsed: false,
// };

// BaseMenu.propTypes = {
//   collapsed: PropTypes.bool,
// };

exports["default"] = BaseMenu;
module.exports = exports['default'];