"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _antd = require("antd");

var _solomonClassPrefix = require("solomon-class-prefix");

var _solomonClassPrefix2 = _interopRequireDefault(_solomonClassPrefix);

var _solomonUtils = require("solomon-utils");

var _kimHeader = require("kim-header");

var _kimHeader2 = _interopRequireDefault(_kimHeader);

var _BaseMenu = require("./BaseMenu");

var _BaseMenu2 = _interopRequireDefault(_BaseMenu);

require("./style.less");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var Content = _antd.Layout.Content;
// import menuData from "./menuData";

/**
 * Author:  liu.yang
 * Date: 2018-05-17 09:42:35
 */

var CLS_PREFIX = "solomon-layout-base";
var addPrefix = (0, _solomonClassPrefix2["default"])(CLS_PREFIX);

var BaseLayout = function (_Component) {
  (0, _inherits3["default"])(BaseLayout, _Component);

  function BaseLayout() {
    var _ref;

    var _temp, _this, _ret;

    (0, _classCallCheck3["default"])(this, BaseLayout);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = (0, _possibleConstructorReturn3["default"])(this, (_ref = BaseLayout.__proto__ || Object.getPrototypeOf(BaseLayout)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      collapsed: false
    }, _this.onCollapse = function () {
      var collapsed = _this.state.collapsed;

      _this.setState({ collapsed: !collapsed });
    }, _temp), (0, _possibleConstructorReturn3["default"])(_this, _ret);
  }

  (0, _createClass3["default"])(BaseLayout, [{
    key: "render",
    value: function render() {
      var _props = this.props,
          children = _props.children,
          menuData = _props.menuData,
          _props$menuOptions = _props.menuOptions,
          menuOptions = _props$menuOptions === undefined ? {} : _props$menuOptions,
          headerOptions = _props.headerOptions,
          className = _props.className;
      var collapsed = this.state.collapsed;
      var selectedkey = menuOptions.selectedkey,
          _menuOptions$fixed = menuOptions.fixed,
          fixedLiftMenu = _menuOptions$fixed === undefined ? false : _menuOptions$fixed,
          _menuOptions$width = menuOptions.width,
          width = _menuOptions$width === undefined ? 256 : _menuOptions$width,
          _menuOptions$miniWidt = menuOptions.miniWidth,
          miniWidth = _menuOptions$miniWidt === undefined ? 80 : _menuOptions$miniWidt;


      var newMenuOptions = {
        collapsed: collapsed,
        menuData: menuData,
        menuOptions: menuOptions
      };
      var newHeaderOptions = (0, _extends3["default"])({
        menuData: menuData,
        menuOptions: menuOptions
      }, headerOptions);

      if (selectedkey) {
        var activeMenus = (0, _solomonUtils.findActiveArray)(selectedkey, menuData);
        newHeaderOptions.breadcrumbData = activeMenus;
        newMenuOptions.menuOptions.defaultOpenKeys = activeMenus.map(function (item) {
          return item.key;
        });
      }
      // const childrenProps = { ...this.props };
      // delete childrenProps.children;

      var _newHeaderOptions$fix = newHeaderOptions.fixed,
          fixedHeader = _newHeaderOptions$fix === undefined ? false : _newHeaderOptions$fix,
          _newHeaderOptions$hea = newHeaderOptions.headerHeight,
          headerHeight = _newHeaderOptions$hea === undefined ? 64 + 54 : _newHeaderOptions$hea;


      var fixedContentStyles = {
        paddingTop: headerHeight + "px"
      };

      if (fixedLiftMenu) {
        fixedContentStyles.paddingLeft = width + "px";
      }
      if (collapsed) {
        fixedContentStyles.paddingLeft = miniWidth + "px";
      }
      return _react2["default"].createElement(
        _antd.Layout,
        {
          className: addPrefix("wrap") + " " + (className && className) + " ant-layout-has-sider"
        },
        _react2["default"].createElement(_BaseMenu2["default"], newMenuOptions),
        _react2["default"].createElement(
          _antd.Layout,
          { id: "solomon-container" },
          _react2["default"].createElement(_kimHeader2["default"], (0, _extends3["default"])({
            collapsed: collapsed,
            onCollapse: this.onCollapse
          }, newHeaderOptions)),
          _react2["default"].createElement(
            Content,
            {
              className: addPrefix("content"),
              style: fixedHeader ? fixedContentStyles : null
            },
            children
          )
        )
      );
    }
  }]);
  return BaseLayout;
}(_react.Component);

exports["default"] = BaseLayout;
module.exports = exports['default'];